unit cnt1c8;
interface
uses
  ComObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_Init: TEdit;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Edit_1C8_Name: TEdit;
    CheckBox1: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1C8_ole : Variant;

  end;

var
  Form1: TForm1;


//  1Cv8 (OLE)
function ConnectTo1C8_Application(s1cAppProgID,InitLine : string;Visible : boolean) : Variant;
//,    (HandleAny)
function YesLinkToVariant(HandleAny : Variant) : boolean;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  //
  s1C8_ole:=UnAssigned;
  Edit_1C8_Name.Text:='V8.Application';
  Edit_Init.Text:='File=F:\1Cv8.DB\Sklad';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  s1C8_ole:=UnAssigned;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  //s1C8_ole:=ConnectTo1C8_Application('V8.Application','File=F:\1Cv8.DB\Sklad');
  s1C8_ole:=UnAssigned;
  s1C8_ole:=ConnectTo1C8_Application(Trim(Edit_1C8_Name.Text),Trim(Edit_Init.Text),CheckBox1.Checked);
  if YesLinkToVariant(s1C8_ole) then begin
     ShowMessage(' ');
  end
  else begin
     ShowMessage('');
  end;
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin
     if CheckBox1.Checked then begin
        //  1Cv8 
        s1C8_ole.Visible:=true;
     end
     else begin
        //  1Cv8 
        s1C8_ole.Visible:=false;
     end;
  end;
end;


function ConnectTo1C8_Application(s1cAppProgID,
                                  InitLine : string;
                                  Visible : boolean) : Variant;
//  1Cv8 (OLE)
{
s1cAppProgID -  1Cv8,   OLE Automation (  ))
   V8.Application
InitLine ( ) :
    .. :
    File=\Trade
    Usr=
    Pwd=
  -  .. :
    Srvr=Server1C ( ,     1)
    Ref=Trade (      1)
    Usr=
    Pwd=
}
//InitLine -  
//Visible -  TRUE,    1Cv8    
//  :   1Cv8,   OLE Automation
//                          Unassigned (  )
Var
  s1CResOpen : integer;
begin
  Result:=Unassigned;
  s1cAppProgID:=Trim(s1cAppProgID);
  if Length(s1cAppProgID)<=0 then s1cAppProgID:='V8.Application';
  InitLine:=Trim(InitLine);
  if Length(s1cAppProgID)>0 then begin
     // 
     Result := CreateOleObject(s1cAppProgID);
     //  
     if YesLinkToVariant(Result) then begin
        //  1Cv8
        s1CResOpen:=Result.Connect(InitLine);
        //   1Cv8
        Result.Visible:=Visible;
     end;
  end;
end;




function YesLinkToVariant(HandleAny : Variant) : boolean;
//,    (HandleAny)
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;


end.



